various fixes mostly for linode
[automated-distro-installer] / fai / config / scripts / GRUB_PC / 11-iank
index 60403dd58e907d3b698f4bae58f1b64337ad7a9e..8f2c7604e9bfd6b1e150c9cbe33fc7c0d3b01b56 100755 (executable)
@@ -13,6 +13,7 @@ if ! type -t fcopy &>/dev/null; then
 fi
 
 chroot $FAI_ROOT bash <<'EOFOUTER'
+set -eE -o pipefail
 if getent group systemd-journal >/dev/null; then
   # makes the journal be saved to disk.
   mkdir -p /var/log/journal
@@ -27,9 +28,9 @@ EOFOUTER
 # -r = recursive
 # -i = ignore non-matching class warnings, always exit 0
 # -B = no backup files
-fcopy -riB /boot
+fcopy -riBM /boot
 # this is also done by FABASE/10-misc by default.
-fcopy -riB /root
+fcopy -riBM /root
 
 
 src=$FAI/distro-install-common/shadow
@@ -42,7 +43,7 @@ fi
 
 $FAI/distro-install-common/end
 if ifclass VOL_STRETCH_BOOTSTRAP; then
-  fcopy -ri /etc/systemd/system
+  fcopy -riM /etc/systemd/system
   chroot $FAI_ROOT bash <<'EOFOUTER'
 systemctl enable fai_check.service
 EOFOUTER
@@ -52,15 +53,19 @@ fi
 
 # these get copied in an earlier stage by fai, but leaving it here since
 # I run this as a single post-fai script to update things that have changed.
-fcopy -riB /etc/apt
+fcopy -riBM /etc/apt
 # outside of fai, this seems to regularly lead to
 # E: Could not get lock /var/lib/apt/lists/lock - open (11: Resource temporarily unavailable)
 # so add a sleep. 1 sec is probably way more than needed.
 sleep 1
-$ROOTCMD apt-get update
+f=$FAI_ROOT/var/cache/apt/pkgcache.bin
+if [[ ! -r $f ]] || (( $(( $(date +%s) - $(stat -c %Y $f ) )) > 60*60*2 )); then
+  $ROOTCMD apt-get update
+fi
 
 
 chroot $FAI_ROOT bash <<'EOF'
+#### begin .ssh setup ###
 set -eE -o pipefail
 mkdir -p /home/iank/.ssh
 f=/root/.ssh/authorized_keys
@@ -70,10 +75,16 @@ fi
 chown -R 1000:1000 /home/iank/.ssh
 chmod -R u=Xrw,og= /home/iank/.ssh
 rm -rf /root/.ssh
+# remove broken symlinks or the following cp will fail
+find /home/iank/.ssh -xtype l -exec rm '{}' \;
 cp -rL /home/iank/.ssh /root
 chown -R root:root /root/.ssh
 chmod 700 /root/.ssh
+#### end .ssh setup ###
 
+# this is needed to enable resolvconf, making /etc/resolv.conf be a symlink.
+# why? i dun know, it\'s really  dumb.
+dpkg-reconfigure -fnoninteractive resolvconf
 
 # default jessie groups + kvm, systemd-journal, adm
 usermod -aG adm,cdrom,floppy,sudo,audio,dip,video,plugdev,netdev iank
@@ -81,25 +92,74 @@ usermod -aG adm,cdrom,floppy,sudo,audio,dip,video,plugdev,netdev iank
 if getent group systemd-journal >/dev/null; then
   usermod -aG systemd-journal iank
 fi
+
+
+# this is usefull. Only thing reason I see this being disabled by default is
+# that a normal user can disrupt the system, eg cause a reboot.
+sed -i '$a kernel.sysrq=1
+/^kernel.sysrq=/d' /etc/sysctl.conf
+EOF
+
+
+if [[ $FAI_ACTION != dirinstall ]]; then
+
+
+  if ifclass LINODE; then
+    speed=19200
+    # luks.crypttab=no see man systemd-cryptsetup-generator
+    cmdline="luks.crypttab=no console=ttyS0,${speed}n8"
+  else
+    speed=115200
+    cmdline="luks.crypttab=no console=ttyS0,${speed} console=tty0"
+  fi
+
+  cat >$FAI_ROOT/etc/grub.d/40_custom <<EOF
+#!/bin/sh
+exec tail -n +3 \$0
+# This file provides an easy way to add custom menu entries.  Simply type the
+# menu entries you want to add after this comment.  Be careful not to change
+# the 'exec tail' line above.
+
+# https://www.coreboot.org/Serial_console # tty
+# but removed unneeded stuff
+
+serial --speed=$speed
+terminal_input --append  serial
+terminal_output --append serial
+EOF
+
+
+  chroot $FAI_ROOT bash <<EOF
+set -eE -o pipefail
 # https://askubuntu.com/questions/33416/how-do-i-disable-the-boot-splash-screen-and-only-show-kernel-and-boot-text-inst
-# it suggests not having plymouth-theme-ubuntu-text, but
-# making it not installed then kills plymouth, then makes
-# the system not boot.
-sed -ri 's/(^ *GRUB_CMDLINE_LINUX.*)quiet splash/\1/' /etc/default/grub
+# we remove quiet and splash, and all thats left is what we want
+
+if grep -qF "$cmdline" /etc/default/grub; then
+  # already set things, exit
+  exit 0
+fi
+sed -ri 's/^ *GRUB_CMDLINE_LINUX_DEFAULT=.*/GRUB_CMDLINE_LINUX_DEFAULT="$cmdline"/' /etc/default/grub
 # on xenial, no grub is displayed at all. fix that.
 # found just by noticing this in the config file, and a
 # warning about it in error.log
 sed -i '/^ *GRUB_HIDDEN_TIMEOUT/d' /etc/default/grub
+
 update-grub2
+EOF
 
-# this is usefull. Only thing reason I see this being disabled by default is
-# that a normal user can disrupt the system, eg cause a reboot.
-sed -i '$a kernel.sysrq=1
-/^kernel.sysrq=/d' /etc/sysctl.conf
+  if [[ ! FAI_WRAPPER ]]; then
+    chroot $FAI_ROOT bash <<EOF
+# Just include all of them for now incase we are creating
+# an install for a different machine.. in distro-begin, we
+# slim it down to whats used.
+find /lib/modules/*/kernel/drivers/net /lib/modules/*/kernel/net -type f -name '*.ko' -printf "%f\n" | sed 's/.ko$//' | sort -u >/etc/initramfs-tools/modules
+update-initramfs -u -k all
 EOF
+  fi
+fi
 
 
-# reading through the groups that iank is in but traci isn't,
+# reading through the groups that iank is in but user2 isn't,
 for g in plugdev audio video cdrom; do
-    $ROOTCMD usermod -a -G $g traci
+  $ROOTCMD usermod -a -G $g user2
 done